## org.apache.hadoop.streaming
Class PipeReducer

    java.lang.Object
      org.apache.hadoop.streaming.PipeMapRed
          org.apache.hadoop.streaming.PipeReducer

All Implemented Interfaces:
  Closeable, JobConfigurable, Reducer

Direct Known Subclasses:
  PipeCombiner

    public class PipeReducer

extends PipeMapRed
implements Reducer

A generic Reducer bridge. It delegates operations to an external program via stdin and stdout.

Field Summary

Fields inherited from class org.apache.hadoop.streaming.PipeMapRed
`LOG, outerrThreadsThrowable`

Constructor Summary
`PipeReducer()`

Method Summary
`void` `close()`
`void` `configure(JobConf job)` Initializes a new instance from a `JobConf`.
`void` `reduce(Object key, Iterator values, OutputCollector output, Reporter reporter)` Reduces values for a given key.

Methods inherited from class org.apache.hadoop.streaming.PipeMapRed
`getContext, mapRedFinished`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PipeReducer

    public PipeReducer()

Method Detail

### configure

    public void configure(JobConf job)

  Description copied from interface: `JobConfigurable`
  Initializes a new instance from a `JobConf`.

  Specified by:
    `configure` in interface `JobConfigurable`
  Overrides:
    `configure` in class `PipeMapRed`
  Parameters:
    `job` - the configuration

### reduce

    public void reduce(Object key,
                       Iterator values,
                       OutputCollector output,
                       Reporter reporter)
                throws IOException

  Description copied from interface: `Reducer`
  Reduces values for a given key.

  The framework calls this method for each `<key, (list of values)>` pair in the grouped inputs. Output values must be of the same type as input values. Input keys must not be altered. The framework will reuse the key and value objects that are passed into the reduce, therefore the application should clone the objects they want to keep a copy of. In many cases, all values are combined into zero or one value.

  Output pairs are collected with calls to `OutputCollector.collect(Object,Object)`.

  Applications can use the `Reporter` provided to report progress or just indicate that they are alive. In scenarios where the application takes an insignificant amount of time to process individual key/value pairs, this is crucial since the framework might assume that the task has timed-out and kill that task. The other way of avoiding this is to set mapred.task.timeout to a high-enough value (or even zero for no time-outs).

  Specified by:
    `reduce` in interface `Reducer`
  Parameters:
    `key` - the key.
    `values` - the list of values to reduce.
    `output` - to collect keys and combined values.
    `reporter` - facility to report progress.
  Throws:
    `IOException`

### close

    public void close()

  Specified by:
    `close` in interface `Closeable`

Copyright © 2009 The Apache Software Foundation